;*******************************************************************************
;* Digitlis technika (VIMIAA03) 12. gyakorlat s laboratrium                 *
;* Stopperra hardveres idzts s megszakts hasznlatval.                 *
;*******************************************************************************
DEF TR   0x82               ; Timer kezdllapot regiszter         (csak rhat)
DEF TM   0x82               ; Timer szmll regiszter             (csak olvashat)
DEF TC   0x83               ; Timer parancs regiszter              (csak rhat)
DEF TS   0x83               ; Timer sttusz regiszter              (csak olvashat)
DEF BT   0x84               ; Nyomgomb adatregiszter              (csak olvashat)
DEF BTIE 0x85               ; Nyomgomb megszakts eng. regiszter (rhat/olvashat)
DEF BTIF 0x86               ; Nyomgomb megszakts flag regiszter (olvashat s a bit 1 bersval trlhet)
DEF DIG0 0x90               ; Kijelz DIG0 adatregiszter           (rhat/olvashat)
DEF DIG1 0x91               ; Kijelz DIG1 adatregiszter           (rhat/olvashat)
DEF DIG2 0x92               ; Kijelz DIG2 adatregiszter           (rhat/olvashat)
DEF DIG3 0x93               ; Kijelz DIG3 adatregiszter           (rhat/olvashat)

; A stopperra llapotai.
DEF IDLE 0x02               ; A stopper nullzva van s ll.
DEF RUN  0x01               ; A stopper fut.
DEF STOP 0x00               ; A stopper ll, mutatja a mrt idt.


    CODE

;*******************************************************************************
;* A program kezdete. A programmemria 0x00 s a 0x01 cme a reset, illetve    *
;* a megszakts vektor. Ide ugr utastsokat kell elhelyezni, amelyek a      *
;* megfelel programrszre ugranak.                                            *
;*******************************************************************************
reset_vector:
    jmp     start           ;Ugrs a program kezdetse.
irq_vector:
    jmp     irq_handler     ;Ugrs a megszaktskezel rutinra.


;*******************************************************************************
;* Fprogram.                                                                  *
;*******************************************************************************
start:

loop:                       ;Vgtelen ciklus. A megszaktskezel rutinban
    jmp     loop            ;vgezzk el a szksges feladatokat.
    

;*******************************************************************************
;* A stopper alapllapotba lltsa.                                           *
;*******************************************************************************
stopper_init:

    rts                     ;Visszatrs a hvhoz.
    
    
;*******************************************************************************
;* Az idzt inicializlsa ismtldses mdban 100 ms peridusidvel s      *
;* megszaktskrssel.                                                        *
;*******************************************************************************
tmr_init:

    rts                     ;Visszatrs a hvhoz.


;*******************************************************************************
;* A nyomgomb perifria inicializlsa. A BT0 llapotvltozsa esetn legyen  *
;* megszaktskrs.                                                           *
;*******************************************************************************
btn_init:

    rts                     ;Visszatrs a hvhoz.
    
    
;*******************************************************************************
;* Egydigites megjelents a htszegmenses kijelzn.                           *
;* Paramterek:                                                                *
;*   r8: A megjelentend szm az als 4 biten, MSb a tizedespont llapota.    *
;*   r9: A hasznland digit regiszter cme.                                   *
;*******************************************************************************
disp_wr:

    rts                     ;Visszatrs a hvhoz.
  

;*******************************************************************************
;* Megszaktskezel rutin.                                                    *
;*******************************************************************************
irq_handler:
    ;Az idzt megszakts ellenrzse.
    
    ;A nyomgomb megszakts ellenrzse.
    
    ;rvnytelen megszakts.
bad_irq:
    jmp     bad_irq         ;Nem vrt megszakts esetn vgtelen ciklus.
    
    ;Az idzt megszakts kezelse.
tmr_irq:
    
    ;A tizedmsodpercek szmllja.
    
    ;A msodpercek szmllja.
    
    ;A tz msodpercek szmllja.
    
    ;A percek szmllja.
    
    ;A szmllk rtknek megjelentse a htszegmenses kijelzn.
disp_refresh:

tmr_irq_end:
    rti                     ;Visszatrs a megszaktsbl.
    
    ;A nyomgomb megszakts kezelse.
btn_irq:

btn_irq_end:
    rti                     ;Visszatrs a megszaktsbl.
    
    
;*******************************************************************************
;* Az adatmemria inicializlsa a htszegmenses dekder tblzattal.          *
;*******************************************************************************
    DATA
    
bin_7seg:
    DB      0x3f, 0x06, 0x5b, 0x4f, 0x66, 0x6d, 0x7d, 0x07
    DB      0x7f, 0x6f, 0x77, 0x7c, 0x39, 0x5e, 0x79, 0x71
